ad_page_contract {

    Add one or more applications to this instance of the portals package

    @author Don Baccus (dhogaza@pacifier.com)
    @creation-date 
    @cvs-id $Id: add-applications-2.tcl,v 1.7 2004/06/26 00:36:01 donb Exp $

} {
    application:multiple
    return_url
}

set package_id [ad_conn package_id]
set node_id [site_node::get_node_id_from_object_id -object_id $package_id]
set non_admin_portals [db_list get_non_admin_portals {}]
set admin_portal_id [portal::get_admin_portal_id]

db_transaction {
    foreach one_application $application {

        # For some reason I'm getting dupes in my application list from the checkboxes
        # set up by the list widget on the previous page.

        if { [db_string check_application {}] == 0 } {

            # First add the datasources associated with the application to our map
            db_dml insert_application {}

            # Now mount the application under our URL
            set application_id [site_node::instantiate_and_mount \
                                   -package_key $one_application \
                                   -parent_node_id $node_id]

            set user_datasources [db_list get_user_datasources {}]

            foreach non_admin_portal $non_admin_portals {
                foreach user_datasource $user_datasources {
                    db_transaction {
                        portal::element::new \
                            -portal_id $non_admin_portal \
                            -state hidden \
                            -datasource_name $user_datasource \
                            -args [list package_id $application_id] \
                            -initialize
                    }
                }
            }

            set admin_datasources [db_list get_admin_datasources {}]
            foreach admin_datasource $admin_datasources {
                db_transaction {
                    portal::element::new \
                        -portal_id $admin_portal_id \
                        -datasource_name $admin_datasource \
                        -args [list package_id $application_id]
                }
            }
        }

    }
}

ad_returnredirect $return_url
